-- Ballenfuttermod by acert 2012
-- Find me at modhoster.de

-- V2.0 Kombigabel 2013 by acert


futtergabel = {};

function futtergabel.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Fillable, specializations);
end;

function futtergabel:load(xmlFile)
	print("---- LOAD MOD: FUTTER-Kombigabel Frontloader by acert ----");
	self.qballmode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ballen.qballmode#index")); -- default type
	self.gpackballmode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ballen.gpackballmode#index"));
	self.rballmode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ballen.rballmode#index"));  
	
	
	self.QBallIsDefault = true
	setVisibility(self.qballmode, true);
	
	self.triggeredBales = {};
	
	self.setFillLevel = Utils.overwrittenFunction(self.setFillLevel, futtergabel.setFillLevel);
	self.BaleTriggerCallback = futtergabel.BaleTriggerCallback;
	if self.isServer then
           self.BaleTriggerId = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.BaleTrigger#index"));
           if self.BaleTriggerId ~= nil then
               addTrigger(self.BaleTriggerId, "BaleTriggerCallback", self);
           end
    end
end;

function futtergabel:delete()
		if self.isServer then
           if self.BaleTriggerId ~= nil then
               removeTrigger(self.BaleTriggerId);
           end
		end
end;

  
function futtergabel:mouseEvent(posX, posY, isDown, isUp, button)
end;

function futtergabel:keyEvent(unicode, sym, modifier, isDown)
end;

function futtergabel:update(dt)
if self:getIsActive() then
		if self:getIsActiveForInput() then
			if InputBinding.hasEvent(InputBinding.MODE1) then		-- from qm to rm																				
							self.isRballMode = true
							self.isQballMode = false
							self.isGPballMode = false
							self.QBallIsDefault = false
							setVisibility(self.qballmode, false);  
							setVisibility(self.gpackballmode, false);
							setVisibility(self.rballmode, true);
			end			
			if InputBinding.hasEvent(InputBinding.MODE2) then			-- from rm to gp
							self.isRballMode = false
							self.isQballMode = false
							self.isGPballMode = true
							self.QBallIsDefault = false
							setVisibility(self.qballmode, false);  
							setVisibility(self.gpackballmode, true);
							setVisibility(self.rballmode, false);
			end		
			if InputBinding.hasEvent(InputBinding.MODE3) then				-- from gp to qm
							self.isRballMode = false
							self.isQballMode = true
							self.isGPballMode = false
							self.QBallIsDefault = false
							setVisibility(self.qballmode, true);  
							setVisibility(self.gpackballmode, false);
							setVisibility(self.rballmode, false);
			end		
		end;
		
	end;
	if self.isServer then
            if self.currentFeedingBale == nil then
                local bale = next(self.triggeredBales);
					if bale ~= nil then	
							self:setFillLevel(bale:getFillLevel(), bale:getFillType(), true);
							self.currentFeedingBale = bale;
							
					end
            end
    end
end;

function futtergabel:updateTick(dt)
end;
	
function futtergabel:onDetach()
self.QBallIsDefault = true
setVisibility(self.qballmode, true);
end;	


function futtergabel:draw()
	if self.QBallIsDefault == true then	
		 g_currentMission:addExtraPrintText(g_i18n:getText("ISQB"));
	end
	if self.isGPballMode == true and self.isQballMode == false and self.isRballMode == false then
		 g_currentMission:addExtraPrintText(g_i18n:getText("ISGP"));
	end;
	if self.isGPballMode == false and self.isQballMode == false and self.isRballMode == true then
		 g_currentMission:addExtraPrintText(g_i18n:getText("ISRB"));
	end;
	if self.isGPballMode == false and self.isQballMode == true and self.isRballMode == false then
		 g_currentMission:addExtraPrintText(g_i18n:getText("ISQB"));
	end;
	if self:getIsActive() then
		g_currentMission:addHelpButtonText(g_i18n:getText("MODE1"), InputBinding.MODE1);
		g_currentMission:addHelpButtonText(g_i18n:getText("MODE2"), InputBinding.MODE2);
		g_currentMission:addHelpButtonText(g_i18n:getText("MODE3"), InputBinding.MODE3);
	end	
end;

function futtergabel:setFillLevel(superFunc, fillLevel, fillType, force)
  
       self.capacity = math.max(self.capacity, fillLevel);
   
       if self.isServer then
           local bale = self.currentFeedingBale;
           if bale ~= nil then
               if fillLevel <= 0 then	
                   bale:delete();
                   self.currentFeedingBale = nil;
                   self.capacity = 1;
                   self.triggeredBales[bale] = nil;
               elseif fillLevel < bale:getFillLevel() and fillType == bale:getFillType() then
                   bale:setFillLevel(fillLevel);
               end
           end
       else
           if fillLevel <= 0 then
               self.capacity = 1;
           end
       end
   
       superFunc(self, fillLevel, fillType, force);
end
   
function futtergabel:BaleTriggerCallback(triggerId, otherActorId, onEnter, onLeave, onStay, otherShapeId)
       if onEnter then
           -- this happens if a compound child of a deleted compound is entering
           if otherActorId ~= 0 then
               local object = g_currentMission:getNodeObject(otherActorId);
               if object ~= nil then
                   if object:isa(Bale) then
                       if self.fillTypes[object:getFillType()] then
                           self.triggeredBales[object] = Utils.getNoNil(self.triggeredBales[object], 0) + 1;
                       end
                   end;
               end;
           end;
       elseif onLeave then
           if otherActorId ~= 0 then
               local object = g_currentMission:getNodeObject(otherActorId);
               if object ~= nil then
                   local triggerCount = self.triggeredBales[object];
                   if triggerCount ~= nil then
                       if triggerCount == 1 then
                           self.triggeredBales[object] = nil;
                           if object == self.currentFeedingBale then
                               self.currentFeedingBale = nil;
                               self:setFillLevel(0, Fillable.FILLTYPE_UNKNOWN, true);
                           end
                       else
                           self.triggeredBales[object] = triggerCount-1;
                       end
                   end
               end
           end
       end;   
end;